Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/EP/ExtremePointsFunctions3D.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/EP/ExtremePointsFunctions3D.cs	(revision 9592)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/EP/ExtremePointsFunctions3D.cs	(revision 9593)
@@ -8,4 +8,5 @@
 using HeuristicLab.Encodings.PackingEncoding.GroupingVector;
 using HeuristicLab.Encodings.PackingEncoding.MultiComponentVector;
+using HeuristicLab.Encodings.PackingEncoding.PackingPlan;
 using HeuristicLab.Encodings.PackingEncoding.PackingSequence;
 using HeuristicLab.Encodings.PermutationEncoding;
@@ -20,6 +21,6 @@
 
 
-    public static ObservableDictionary<int, ThreeDimensionalPacking> ExtremePointBasedPacking(ref MultiComponentVectorEncoding solution, 
-        ItemList<CuboidPackingItem> itemMeasures, CuboidPackingBin binMeasures) {
+    public static ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>> ExtremePointBasedPacking(ref MultiComponentVectorEncoding solution, 
+        ItemList<CuboidPackingItem> itemMeasures, CuboidPackingBin binMeasures, bool stackingConstraints) {
 
       #region Preperations
@@ -97,10 +98,10 @@
       }
 
-      return itemPositions;
-    }
-
-
-    public static ObservableDictionary<int, ThreeDimensionalPacking> ExtremePointBasedPacking(GroupingVectorEncoding solution,
-        ItemList<CuboidPackingItem> itemMeasures, CuboidPackingBin binMeasures) {
+      return BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>.GetBinPackings(itemPositions, binMeasures, itemMeasures, nrOfBins);
+    }
+
+
+    public static ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>> ExtremePointBasedPacking(GroupingVectorEncoding solution,
+        ItemList<CuboidPackingItem> itemMeasures, CuboidPackingBin binMeasures, bool stackingConstraints) {
 
       #region Preperations
@@ -139,5 +140,5 @@
 
           extremePointsForBin[binNr] = OrderExtremePoints(extremePointsForBin[binNr], occupiedPoints, binMeasures);
-          var positionFound = FindExtremePointForItem(itemIndex, itemMeasures, binMeasures, extremePointsForBin[binNr], occupiedPoints, itemPositions);
+          var positionFound = FindExtremePointForItem(itemIndex, itemMeasures, binMeasures, extremePointsForBin[binNr], occupiedPoints, itemPositions, stackingConstraints);
           if (positionFound != null) {
             extremePointsForBin[binNr].Remove(positionFound);
@@ -162,5 +163,5 @@
 
           extremePointsForBin[binNr] = OrderExtremePoints(extremePointsForBin[binNr], occupiedPoints, binMeasures);
-          var positionFound = FindExtremePointForItem(itemIndex, itemMeasures, binMeasures, extremePointsForBin[binNr], occupiedPoints, itemPositions);
+          var positionFound = FindExtremePointForItem(itemIndex, itemMeasures, binMeasures, extremePointsForBin[binNr], occupiedPoints, itemPositions, stackingConstraints);
           if (positionFound != null) {
             extremePointsForBin[binNr].Remove(positionFound);
@@ -179,10 +180,10 @@
       }
 
-      return itemPositions;
-    }
-
-
-    public static ObservableDictionary<int, ThreeDimensionalPacking> ExtremePointBasedPacking(PackingSequenceEncoding solution, 
-        ItemList<CuboidPackingItem> itemMeasures, CuboidPackingBin binMeasures) {
+      return BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>.GetBinPackings(itemPositions, binMeasures, itemMeasures, nrOfBins);
+    }
+
+
+    public static ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>> ExtremePointBasedPacking(PackingSequenceEncoding solution,
+        ItemList<CuboidPackingItem> itemMeasures, CuboidPackingBin binMeasures, bool stackingConstraints) {
 
       #region Preperations 
@@ -200,5 +201,5 @@
         var item = itemMeasures[itemIndex];
         extremePoints = OrderExtremePoints(extremePoints, occupiedPoints, binMeasures);
-        var positionFound = FindExtremePointForItem(itemIndex, itemMeasures, binMeasures, extremePoints, occupiedPoints, itemPositions);
+        var positionFound = FindExtremePointForItem(itemIndex, itemMeasures, binMeasures, extremePoints, occupiedPoints, itemPositions, stackingConstraints);
         if (positionFound != null) {
           extremePoints.Remove(positionFound); 
@@ -214,12 +215,40 @@
       }
 
-      return itemPositions;
-    }
+      return BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>.GetBinPackings(itemPositions, binMeasures, itemMeasures, nrOfBins);
+    }
+
+
 
 
     public static ThreeDimensionalPacking FindExtremePointForItem(int itemIndex, ItemList<CuboidPackingItem> itemMeasures, CuboidPackingBin binMeasures,
-        HashSet<ThreeDimensionalPacking> extremePoints, List<int[, ,]> occupiedPoints, ObservableDictionary<int, ThreeDimensionalPacking> itemPositions) {
-          return FindExtremePointForItem(itemIndex, itemMeasures, binMeasures, extremePoints, occupiedPoints, itemPositions, false);
-    }
+        HashSet<ThreeDimensionalPacking> extremePoints, List<int[, ,]> occupiedPoints, ObservableDictionary<int, ThreeDimensionalPacking> itemPositions, bool stackingConstraints) {
+          return FindExtremePointForItem(itemIndex, itemMeasures, binMeasures, extremePoints, occupiedPoints, itemPositions, stackingConstraints, false);
+    }
+    public static ThreeDimensionalPacking FindExtremePointForItem(int itemIndex, ItemList<CuboidPackingItem> itemMeasures, CuboidPackingBin binMeasures,
+        HashSet<ThreeDimensionalPacking> extremePoints, List<int[, ,]> occupiedPoints, ObservableDictionary<int, ThreeDimensionalPacking> itemPositions, bool stackingConstraints, bool rotated) {
+
+      var itemFromList = itemMeasures[itemIndex];
+      CuboidPackingItem item = new CuboidPackingItem(
+        rotated ? itemFromList.Depth : itemFromList.Width, 
+        itemFromList.Height, 
+        rotated ? itemFromList.Width : itemFromList.Depth,
+        itemFromList.TargetBin);
+
+      int epIndex = 0;
+      while (epIndex < extremePoints.Count &&    
+        //(!IsPositionFeasible(binMeasures, item, extremePoints.ElementAt(epIndex), occupiedPoints) ||
+        (!DeepestBottomLeftFunctions.IsPositionFeasible(binMeasures, extremePoints.ElementAt(epIndex).AssignedBin, item, extremePoints.ElementAt(epIndex), itemPositions, itemMeasures) ||
+        (stackingConstraints && !IsStaticStable(occupiedPoints[extremePoints.ElementAt(epIndex).AssignedBin], item, extremePoints.ElementAt(epIndex))))) 
+      { epIndex++; }
+
+      if (epIndex < extremePoints.Count) {
+        var result = extremePoints.ElementAt(epIndex);
+        result.Rotated = rotated;
+        return result;
+      } 
+      return null;
+    }
+
+
     public static ThreeDimensionalPacking FindExtremePointForItemUsingMaterialAndWeightConstraint(int itemIndex, ItemList<CuboidPackingItem> itemMeasures, CuboidPackingBin binMeasures,
        HashSet<ThreeDimensionalPacking> extremePoints, List<int[, ,]> occupiedPoints, ObservableDictionary<int, ThreeDimensionalPacking> itemPositions, bool rotated) {
@@ -234,4 +263,5 @@
       int epIndex = 0;
       while (epIndex < extremePoints.Count &&
+        //(!IsPositionFeasible(binMeasures, item, extremePoints.ElementAt(epIndex), occupiedPoints) ||  
         (!DeepestBottomLeftFunctions.IsPositionFeasible(binMeasures, extremePoints.ElementAt(epIndex).AssignedBin, item, extremePoints.ElementAt(epIndex), itemPositions, itemMeasures) ||
         !IsStaticStable(occupiedPoints[extremePoints.ElementAt(epIndex).AssignedBin], item, extremePoints.ElementAt(epIndex)) ||
@@ -243,27 +273,4 @@
         return result;
       }
-      return null;
-    }
-    public static ThreeDimensionalPacking FindExtremePointForItem(int itemIndex, ItemList<CuboidPackingItem> itemMeasures, CuboidPackingBin binMeasures, 
-        HashSet<ThreeDimensionalPacking> extremePoints, List<int[,,]> occupiedPoints, ObservableDictionary<int, ThreeDimensionalPacking> itemPositions, bool rotated) {
-
-      var itemFromList = itemMeasures[itemIndex];
-      CuboidPackingItem item = new CuboidPackingItem(
-        rotated ? itemFromList.Depth : itemFromList.Width, 
-        itemFromList.Height, 
-        rotated ? itemFromList.Width : itemFromList.Depth,
-        itemFromList.TargetBin);
-
-      int epIndex = 0;
-      while (epIndex < extremePoints.Count &&
-        (!DeepestBottomLeftFunctions.IsPositionFeasible(binMeasures, extremePoints.ElementAt(epIndex).AssignedBin, item, extremePoints.ElementAt(epIndex), itemPositions, itemMeasures) ||
-        !IsStaticStable(occupiedPoints[extremePoints.ElementAt(epIndex).AssignedBin], item, extremePoints.ElementAt(epIndex)))) 
-      { epIndex++; }
-
-      if (epIndex < extremePoints.Count) {
-        var result = extremePoints.ElementAt(epIndex);
-        result.Rotated = rotated;
-        return result;
-      } 
       return null;
     }
@@ -439,4 +446,6 @@
       return shortestSide;
     }
+
+    
   }
 }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/EP/ISOContainerMultiComponentVectorDecoder3D.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/EP/ISOContainerMultiComponentVectorDecoder3D.cs	(revision 9592)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/EP/ISOContainerMultiComponentVectorDecoder3D.cs	(revision 9593)
@@ -62,6 +62,6 @@
       
       PackingPlan<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem> result =
-        new PackingPlan<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>(new ObservableDictionary<int, CuboidPackingBin>(), itemMeasures);
-
+        new PackingPlan<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>();
+                                                                   /*
       #region Preperations
       int nrOfBins = solution.NrOfBins;
@@ -153,6 +153,5 @@
       }
 
-      result.PackingItemPositions = itemPositions;
-      result.PackingBinMeasures = resultingBinMeasures;
+      result.BinPackings = BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>.GetBinPackings(itemPositions, resultingBinMeasures, itemMeasures, nrOfBins);   */
       return result;
     }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/ThreeDimensionalPackingFunctions.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/ThreeDimensionalPackingFunctions.cs	(revision 9593)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/ThreeDimensionalPackingFunctions.cs	(revision 9593)
@@ -0,0 +1,205 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Collections;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PackingEncoding.GroupingVector;
+using HeuristicLab.Encodings.PackingEncoding.MultiComponentVector;
+using HeuristicLab.Encodings.PackingEncoding.PackingPlan;
+using HeuristicLab.Encodings.PackingEncoding.PackingSequence;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Problems.BinPacking.Dimensions;
+using HeuristicLab.Problems.BinPacking.Interfaces;
+using HeuristicLab.Problems.BinPacking.PackingBin;
+using HeuristicLab.Problems.BinPacking.PackingItem;
+using HeuristicLab.Problems.BinPacking.Shapes;
+
+namespace HeuristicLab.Problems.BinPacking.Decoders {
+  public static class ThreeDimensionalPackingFunctions {
+
+    public static ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>> DeepestLeftBottomPacking(
+     MultiComponentVectorEncoding solution, CuboidPackingBin binMeasures, ItemList<CuboidPackingItem> itemMeasures) {
+
+       ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>> result =
+       new ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>>();
+
+     var sequenceMatrix = SequentialPackingFunctions.GenerateSequenceMatrix(solution);
+     Dictionary<int, bool> rotated = SequentialPackingFunctions.GenerateRotationArray(solution);
+          
+     //Fill bins according to grouping vector
+     List<int> remainingIDs = new List<int>();
+     foreach (var sequence in sequenceMatrix) {
+       remainingIDs = remainingIDs.Concat(sequence).ToList();
+       result.Add(SequentialPackingFunctions.DeepestLeftBottomPacking(ref remainingIDs, binMeasures, itemMeasures, rotated));
+     }
+
+     //Try to put remaining items in existing bins
+     var temp = new List<int>(remainingIDs);
+     foreach (int id in temp) {
+       foreach (var bp in result) {
+         var position = bp.FindPositionBySliding(itemMeasures[id], rotated[id]);
+         if (position != null) {
+           bp.PackItem(id, itemMeasures[id], position);
+           remainingIDs.Remove(id);
+         }
+       }
+     }
+
+     //Put still remaining items in new bins
+     while (remainingIDs.Count > 0) {
+       result.Add(SequentialPackingFunctions.DeepestLeftBottomPacking(ref remainingIDs, binMeasures, itemMeasures));
+     }
+
+     return result;
+   }
+
+    public static ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>> DeepestLeftBottomPacking(
+     GroupingVectorEncoding solution, CuboidPackingBin binMeasures, ItemList<CuboidPackingItem> itemMeasures) {
+
+       ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>> result =
+       new ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>>();
+
+     var sequenceMatrix = SequentialPackingFunctions.GenerateSequenceMatrix(solution);
+          
+     //Fill bins according to grouping vector
+     List<int> remainingIDs = new List<int>();
+     foreach (var sequence in sequenceMatrix) {
+       remainingIDs = remainingIDs.Concat(sequence).ToList();
+       result.Add(SequentialPackingFunctions.DeepestLeftBottomPacking(ref remainingIDs, binMeasures, itemMeasures));
+     }
+
+     //Try to put remaining items in existing bins
+     var temp = new List<int>(remainingIDs);
+     foreach (int id in temp) {
+       foreach (var bp in result) {
+         var position = bp.FindPositionBySliding(itemMeasures[id], false);
+         if (position != null) {
+           bp.PackItem(id, itemMeasures[id], position);
+           remainingIDs.Remove(id);
+         }
+       }
+     }
+
+     //Put still remaining items in new bins
+     while (remainingIDs.Count > 0) {
+       result.Add(SequentialPackingFunctions.DeepestLeftBottomPacking(ref remainingIDs, binMeasures, itemMeasures));
+     }
+
+     return result;
+   }
+
+   public static ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>> DeepestLeftBottomPacking(
+     PackingSequenceEncoding solution, CuboidPackingBin binMeasures, ItemList<CuboidPackingItem> itemMeasures) {
+
+       ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>> result =
+       new ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>>();
+
+     List<int> remainingIDs = new List<int>(solution.PackingSequence);
+     while (remainingIDs.Count > 0) {
+       result.Add(SequentialPackingFunctions.DeepestLeftBottomPacking(ref remainingIDs, binMeasures, itemMeasures));
+     }
+
+     return result;
+   }
+
+
+
+
+   public static ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>> ExtremePointBasedPacking(
+     MultiComponentVectorEncoding solution, ItemList<CuboidPackingItem> itemMeasures, CuboidPackingBin binMeasures, bool stackingConstraints) {
+
+     ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>> result =
+       new ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>>();
+
+     var sequenceMatrix = SequentialPackingFunctions.GenerateSequenceMatrix(solution);
+     Dictionary<int, bool> rotated = SequentialPackingFunctions.GenerateRotationArray(solution);
+
+     //Fill bins according to grouping vector
+     List<int> remainingIDs = new List<int>();
+     foreach (var sequence in sequenceMatrix) {
+       remainingIDs = remainingIDs.Concat(sequence).ToList();
+       result.Add(SequentialPackingFunctions.ExtremePointBasedPacking(ref remainingIDs, binMeasures, itemMeasures, stackingConstraints, rotated));
+     }
+
+     result = new ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>>(result.OrderByDescending(x => x.PackingDensity));
+
+     //Try to put remaining items in existing bins
+     var temp = new List<int>(remainingIDs);
+     foreach (int id in temp) {
+       foreach (var bp in result) {
+         var position = bp.FindExtremePointForItem(itemMeasures[id], rotated[id], stackingConstraints);
+         if (position != null) {
+           bp.PackItem(id, itemMeasures[id], position);
+           remainingIDs.Remove(id);
+         }
+       }
+     }
+
+     //Put still remaining items in new bins
+     while (remainingIDs.Count > 0) {
+       result.Add(SequentialPackingFunctions.ExtremePointBasedPacking(ref remainingIDs, binMeasures, itemMeasures, stackingConstraints));
+     }
+            
+      result.RemoveAll(x => x.ItemPositions.Count == 0);
+      return new ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>>(result.OrderByDescending(x => x.PackingDensity));
+   }
+
+   public static ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>> ExtremePointBasedPacking(
+     GroupingVectorEncoding solution, ItemList<CuboidPackingItem> itemMeasures, CuboidPackingBin binMeasures, bool stackingConstraints) {
+
+     ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>> result =
+       new ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>>();
+
+     var sequenceMatrix = SequentialPackingFunctions.GenerateSequenceMatrix(solution);
+
+     //Fill bins according to grouping vector
+     List<int> remainingIDs = new List<int>();
+     foreach (var sequence in sequenceMatrix) {
+       remainingIDs = remainingIDs.Concat(sequence).ToList();
+       result.Add(SequentialPackingFunctions.ExtremePointBasedPacking(ref remainingIDs, binMeasures, itemMeasures, stackingConstraints));
+     }
+
+     result = new ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>>(result.OrderByDescending(x => x.PackingDensity));
+
+     //Try to put remaining items in existing bins
+     var temp = new List<int>(remainingIDs);
+     foreach (int id in temp) {
+       foreach (var bp in result) {
+         var position = bp.FindExtremePointForItem(itemMeasures[id], false, stackingConstraints);
+         if (position != null) {
+           bp.PackItem(id, itemMeasures[id], position);
+           remainingIDs.Remove(id);
+           break;
+         }
+       }
+     }
+
+     //Put still remaining items in new bins
+     while (remainingIDs.Count > 0) {
+       result.Add(SequentialPackingFunctions.ExtremePointBasedPacking(ref remainingIDs, binMeasures, itemMeasures, stackingConstraints));
+     }
+
+     result.RemoveAll(x => x.ItemPositions.Count == 0);
+     return new ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>>(result.OrderByDescending(x => x.PackingDensity));
+   }
+
+   public static ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>> ExtremePointBasedPacking(
+     PackingSequenceEncoding solution, ItemList<CuboidPackingItem> itemMeasures, CuboidPackingBin binMeasures, bool stackingConstraints) {
+
+     ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>> result =
+       new ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>>();
+
+
+     List<int> remainingIDs = new List<int>(solution.PackingSequence);
+     while (remainingIDs.Count > 0) {
+       result.Add(SequentialPackingFunctions.ExtremePointBasedPacking(ref remainingIDs, binMeasures, itemMeasures, stackingConstraints));
+     }
+
+     result.RemoveAll(x => x.ItemPositions.Count == 0);
+     return new ObservableList<BinPacking<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>>(result.OrderByDescending(x => x.PackingDensity));
+   }
+
+    
+  }
+}
